package Zaehler;

public class Counter {

		private static long maximum = 1000;
		private static long minimum = 0;
		
		private long count = getMinimum();
		
		public synchronized long getMinimum(){
			return minimum;
		}
		public synchronized long getMaximum(){
			return maximum;
		}
		
		public synchronized long getCount(){
			return count;
		}
		
		public synchronized void setCount(long c){
			count = c;
			System.out.println(Thread.currentThread() + " Count: " + count);
			notifyAll();
		}
		
		private synchronized void warteBisInkrementierbar(){
			while (getCount() >= getMaximum()){
				try { wait();
				} catch (InterruptedException ie){}
			}
		}
		
		private synchronized void warteBisDekrementierbar(){
			while (getCount() <= getMinimum()){
				try { wait();
				} catch (InterruptedException ie){}
			}
		}
		
		public synchronized void increment(){
			warteBisInkrementierbar();
			setCount(++count);
		}
		
		public synchronized void decrement(){
			warteBisDekrementierbar();
			setCount(--count);
		}
}
